/* eslint-disable no-var */
// @ts-ignore
"use strict";

var App = { };

// When adding namespace declarations, please consider needs of those using VSCode:
// when you declare App.A{ A1:{}, A2:{} }, VSCode considers A, A1, and A2 to be
// sealed namespaces and no new members are added to them with nested declaration later on.
// This breaks code completion completely. Please instead declare them as:
// App.A = {}; App.A.A1 = {}; App.A.A2 = {}. Thank you.

// Also, such declaration basically required only for namespaces that span more than a single file.

App.Arcology = {};
App.Arcology.Cell = {};
App.Art = {};
App.Corporate = {};
App.Data = {};
App.Data.FCTV = {};
App.Data.HeroSlaves = {};
App.Data.Policies = {};
App.Data.Policies.Selection = {};
App.Data.Weather = {};
App.Debug = {};
App.Desc = {};
App.Desc.Player = {};
App.Encyclopedia = {};
App.Encyclopedia.Entries = {};
App.EndWeek = {};
App.Entity = {};
App.Entity.Utils = {};
App.Events = {};
App.Facilities = {};
App.Facilities.Arcade = {};
App.Facilities.Brothel = {};
App.Facilities.Cellblock = {};
App.Facilities.Clinic = {};
App.Facilities.Club = {};
App.Facilities.Dairy = {};
App.Facilities.Farmyard = {};
App.Facilities.HGSuite = {};
App.Facilities.MasterSuite = {};
App.Facilities.Nursery = {};
App.Facilities.Schoolroom = {};
App.Facilities.ServantsQuarters = {};
App.Facilities.Spa = {};
App.Interact = {};
App.Intro = {};
App.Neighbor = {};
App.MainView = {};
App.Markets = {};
App.Medicine = {};
App.Medicine.Modification = {};
App.Medicine.Modification.Brands = {};
App.Medicine.Modification.Select = {};
App.Medicine.OrganFarm = {};
App.Medicine.OrganFarm.Organs = {};
App.Medicine.Salon = {};
App.Medicine.Surgery = {};
App.RA = {};
App.Reminders = {};
App.SF = {};
App.SecExp = {};
App.SlaveAssignment = {};
App.UI = {};
App.UI.Budget = {};
App.UI.DOM = {};
App.UI.DOM.Widgets = {};
App.UI.SlaveInteract = {};
App.UI.View = {};
App.Update = {};
App.Utils = {};
