/**
 * @param {App.Entity.SlaveState} slave
 * @returns {number}
 */
App.Facilities.Farmyard.farmShowsIncome = function(slave) {
	const
		arcology = V.arcologies[0],
		heavyMods = SlaveStatsChecker.modScore(slave).total > 20,

		sexualQuirks = ["perverted", "unflinching"],
		behavioralQuirks = ["sinful"],
		fetishes = ["humiliation", "masochist"];

	let cash = 7500;

	if (!slave) {
		return null;
	} else {
		if (S.Farmer) {
			cash *= 1.1;
			if (S.Farmer.skill.farmer >= V.masteredXP) {
				cash *= 1.1;
			}
		}

		// MARK: FS Effects

		if (arcology.FSSupremacist !== "unset") {
			if (isSuperiorRace(slave)) {
				if (V.seeBestiality) {
					cash *= 0.8;
					repX(-10, "shows");
				} else {
					cash *= 1.2;
				}
			} else {
				cash *= 0.9;
			}
		}

		if (arcology.FSSubjugationist !== "unset") {
			if (isInferiorRace(slave)) {
				if (V.seeBestiality) {
					cash *= 1.2;
					repX(10, "shows");
				} else {
					cash *= 0.8;
				}
			} else {
				cash *= 0.9;
			}
		}

		if (arcology.FSRepopulationFocus !== "unset") {
			if (isPreg(slave)) {
				if (slave.eggType === "human") {
					cash *= 1.2;
					repX(15, "shows");
				} else {
					cash *= 0.8;
					repX(-15, "shows");
				}
			}
		}

		if (arcology.FSRestart !== "unset") {
			if (isPreg(slave)) {
				if (isEliteBreeder(slave)) {
					if (slave.eggType === "human") {
						cash *= 0.7;
						repX(-20, "shows");
					} else {
						cash *= 0.6;
						repX(-25, "shows");
					}
				} else {
					if (slave.eggType === "human") {
						cash *= 0.8;
						repX(-15, "shows");
					} else {
						cash += 0.9;
						repX(-10, "shows");
					}
				}
			} else {
				if (V.seeBestiality && isEliteBreeder(slave)) {
					cash *= 0.7;
					repX(-10, "shows");
				}
			}
		}

		if (arcology.FSGenderRadicalist !== "unset") {
			if (slave.genes === "XX") {
				if (slave.dick > 0) {
					cash *= 1.2;
					repX(10, "shows");
				} else {
					cash *= 0.9;
					repX(-5, "shows");
				}
			}
		}

		if (arcology.FSGenderFundamentalist !== "unset") {
			if (isPreg(slave) || setup.fakeBellies.includes(slave.bellyAccessory)) {
				cash *= 1.1;
				repX(10, "shows");
			} else {
				cash *= 0.9;
				repX(-5, "shows");
			}

			// FIXME: keep this? not sure it makes sense
			if (slave.genes === "XX") {
				if (slave.dick > 0) {
					cash *= 0.8;
				} else {
					cash *= 1.1;
				}
			}
		}

		if (arcology.FSPaternalist !== "unset") {
			if (V.seeBestiality) {
				if (V.farmyardBreeding) {
					if (V.farmyardRestraints) {
						cash *= 0.5;
					} else {
						cash *= 0.7;
					}
				} else {
					if (V.farmyardRestraints) {
						cash *= 0.8;
					} else {
						cash *= 0.9;
					}
				}
			} else {
				// TODO: something here?
			}
		}

		if (arcology.FSDegradationist !== "unset") {
			if (V.seeBestiality) {
				if (V.farmyardBreeding) {
					if (V.farmyardRestraints) {
						cash *= 1.5;
					} else {
						cash *= 1.3;
					}
				} else {
					if (V.farmyardRestraints) {
						cash *= 1.2;
					} else {
						cash *= 1.1;
					}
				}
			} else {
				// TODO: something here?
			}
		}

		if (arcology.FSBodyPurist !== "unset") {
			if (SlaveStatsChecker.isModded(slave)) {
				if (heavyMods) {
					cash *= 0.7;
					repX(-15, "shows");
				} else {
					cash *= 0.8;
					repX(-10, "shows");
				}
			}
		}

		if (arcology.FSTransformationFetishist !== "unset") {
			if (SlaveStatsChecker.isModded(slave)) {
				if (heavyMods) {
					cash *= 1.3;
					repX(15, "shows");
				} else {
					cash *= 1.2;
					repX(10, "shows");
				}
			}
		}

		if (arcology.FSYouthPreferentialist !== "unset") {
			if (isYoung(slave)) {
				cash *= 1.2;
				repX(10, "shows");
			} else {
				cash *= 0.8;
				repX(-5, "shows");
			}
		}

		if (arcology.FSMaturityPreferentialist !== "unset") {
			if (!isYoung(slave)) {
				cash *= 1.2;
				repX(10, "shows");
			} else {
				cash *= 0.8;
				repX(-5, "shows");
			}
		}

		if (arcology.FSSlimnessEnthusiast !== "unset") {
			if (slimLawPass(slave)) {
				cash *= 1.1;
				repX(10, "shows");
			} else {
				cash *= 0.9;
				repX(-5, "shows");
			}
		}

		// FIXME: marked for possible rewrite
		if (arcology.FSAssetExpansionist !== "unset") {
			if (isStacked(slave)) {
				cash *= 1.1;
				repX(10, "shows");
			}
		}

		if (arcology.FSPastoralist !== "unset") {
			if (slave.boobs >= 1000) {
				cash *= 1.2;
				repX(10, "shows");
			}

			if (slave.lactation > 0) {
				cash *= 1.1;
				repX(5, "shows");
			}
		}

		// FIXME: marked for review
		if (arcology.FSPhysicalIdealist !== "unset") {
			if (genderLawPass(slave)) {
				cash *= 1.1;
				repX(10, "shows");
			} else {
				cash *= 0.9;
				repX(-5, "shows");
			}

			if (slave.muscles > 30) {								// slave is muscular or more
				cash *= 1.1;
			} else {
				cash *= 0.9;
			}
		}

		if (arcology.FSHedonisticDecadence !== "unset") {
			if (slave.weight > 10) {								// slave is curvy or more
				cash *= 1.1;
			} else {
				cash *= 0.9;
			}
		}

		if (arcology.FSChattelReligionist !== "unset") { 			// TODO: I don't know what to put for this one
			if (slave.devotion < 21) { 								// if slave is careful or less
				cash *= 0.9;
			}
		}

		if (arcology.FSPetiteAdmiration !== "unset") {
			if (heightPass(slave)) {
				cash *= 1.1;
				repX(10, "shows");
			} else {
				cash *= 0.9;
				repX(-5, "shows");
			}
		}

		if (arcology.FSStatuesqueGlorification !== "unset") {
			if (heightPass(slave)) {
				cash *= 1.1;
				repX(10, "shows");
			} else {
				cash *= 0.9;
				repX(-5, "shows");
			}
		}

		if (arcology.FSRomanRevivalist !== "unset") {
			// TODO:
		}

		if (arcology.FSAztecRevivalist !== "unset") {
			// TODO:
		}

		if (arcology.FSEgyptianRevivalist !== "unset") {
			// TODO:
		}

		if (arcology.FSEdoRevivalist !== "unset") {
			// TODO:
		}

		if (arcology.FSArabianRevivalist !== "unset") {
			// TODO:
		}

		if (arcology.FSChineseRevivalist !== "unset") {
			// TODO:
		}

		// Close FS Effects

		if (setup.entertainmentCareers.includes(slave.career)) {
			cash *= 1.1;
		}

		// FIXME: can slaves' careers overlap categories?
		if (setup.farmerCareers.includes(slave.career)) {
			cash *= 1.1;
		}

		if (slave.prestige === 1) { 								// slave is prestigious
			cash *= 1.1;
		} else if (slave.prestige === 2) { 							// slave is very prestigious
			cash *= 1.5;
		} else if (slave.prestige === 3) { 							// slave is extremely prestigious
			cash *= 1.9;
		}

		if (slave.porn.prestige === 1) { 							// slave is prestigious from porn
			cash *= 1.1;
		} else if (slave.porn.prestige === 2) { 					// slave is very prestigious from porn
			cash *= 1.4;
		} else if (slave.porn.prestige === 3) { 					// slave is extremely prestigious from porn
			cash *= 1.7;
		}

		// FIXME: needed when using healthPenalty()?
		if (slave.health.condition > 50) {							// slave is very healthy or more
			cash *= 1.2;
		} else if (slave.health.condition < -20) {
			cash *= 0.9;
		}

		// TODO: add checks for family and relationships

		if (slave.face > 40) {										// slave is beautiful or more
			cash *= 1.4;
		} else if (slave.face > 10) {								// slave is very pretty or more
			cash *= 1.1;
		} else if (slave.face < -10) {								// slave is less than unattractive
			cash *= 0.9;
		} else if (slave.face < -40) {								// slave is less than ugly
			cash *= 0.7;
		}

		setSlaveDevotion(cash);
		setSlaveTrust(cash);

		if (slave.weight > 30) { 									// slave is curvy or more
			if (arcology.FSHedonisticDecadence !== "unset") {
				cash *= 0.8;
			}
		} else if (slave.weight < -30) { 							// slave is very thin or less
			cash *= 0.8;											// TODO: put this on a scale
		}

		// FIXME: marked for rewrite
		if (slave.muscles > 30) { 									// slave is muscular or more
			cash *= 0.9;
		} else if (slave.muscles < -30) {							// slave is very weak or less
			cash *= 0.6;
		}

		if (!canSeePerfectly(slave)) {
			if (canSee(slave)) {
				cash *= 0.8;
			} else {
				cash *= 0.6;
			}
		}

		if (!canHear(slave)) {
			cash *= 0.8;
		}

		if (isPreg(slave)) {
			cash *= 0.8;											// TODO: not sure how to incorporate pregnancy
		}
		// TODO: incorporate skills
		cash *= healthPenalty(slave);

		if (slave.intelligence > 50) {								// slave is very smart or better
			cash *= 1.4;
		} else if (slave.intelligence < -50) {						// slave is very slow or less
			cash *= 0.6;
		}

		if (slave.energy > 95) {									// slave is a nymphomaniac
			cash *= 1.5;
		} else if (slave.energy > 80) {								// slave has powerful sex drive
			cash *= 1.3;
		} else if (slave.energy > 60) {								// slave has good sex drive
			cash *= 1.1;
		} else if (slave.energy > 40) {								// slave has average sex drive
			cash *= 0.9;
		} else if (slave.energy > 20) {								// slave has poor sex drive
			cash *= 0.8;
		} else {													// slave has no sex drive
			cash *= 0.6;
		}

		switch (slave.fetish) {
			case "submissive":
			case "humiliation":
				if (V.seeBestiality) {
					if (slave.fetishKnown) {
						cash *= 1.1;
					} else {
						slave.fetishKnown = jsRandom(1, 100) > 80 ? 1 : 0;
					}
				} else {
					if (slave.fetishKnown) {
						cash *= 0.9;
					} else {
						slave.fetishKnown = jsRandom(1, 100) > 80 ? 1 : 0;
					}
				}
				break;

			default:
				break;
		}

		switch (slave.behavioralFlaw) {
			case "devout":
			case "arrogant":
				cash *= 0.9;
				break;

			default:
				break;
		}

		switch (slave.behavioralQuirk) {
			case "sinful":
				cash *= 1.1;
				break;

			default:
				break;
		}

		switch (slave.sexualFlaw) {
			case "shamefast":
				cash *= 1.1;
				break;

			default:
				break;
		}

		switch (slave.sexualQuirk) {
			case "perverted":
				cash *= 1.1;
				break;

			default:
				break;
		}

		return cash;
	}

	function setSlaveDevotion(amount) {
		const slaveApproves = () =>
			sexualQuirks.includes(slave.sexualQuirk) ||
			behavioralQuirks.includes(slave.behavioralQuirk) ||
			fetishes.includes(slave.fetish);

		if (slave.devotion > 50) {
			amount *= 1.5;

			if (V.seeBestiality) {
				if (slaveApproves) {
					slave.devotion += 2;
				} else {
					slave.devotion--;
				}
			}

			if (V.farmyardBreeding) {
				if (slaveApproves) {
					slave.devotion += 2;
				} else {
					slave.devotion--;
				}
			}

			if (V.farmyardRestraints) {
				if (slaveApproves) {
					slave.devotion += 3;
				} else {
					slave.devotion -= 2;
				}
			}
		} else if (slave.devotion < -50) {
			amount *= 0.5;

			if (V.seeBestiality) {
				if (slaveApproves) {
					slave.devotion++;
				} else {
					slave.devotion -= 2;
				}
			}

			if (V.farmyardBreeding) {
				if (slaveApproves) {
					slave.devotion++;
				} else {
					slave.devotion -= 2;
				}
			}

			if (V.farmyardRestraints) {
				if (slaveApproves) {
					slave.devotion += 2;
				} else {
					slave.devotion -= 3;
				}
			}
		}

		return amount;
	}

	function setSlaveTrust(amount) {
		const slaveApproves = () =>
			sexualQuirks.includes(slave.sexualQuirk) ||
			behavioralQuirks.includes(slave.behavioralQuirk) ||
			fetishes.includes(slave.fetish);

		if (slave.trust > 50) {
			amount *= 1.2;

			if (V.seeBestiality) {
				if (slaveApproves) {
					slave.trust += 2;
				} else {
					slave.trust--;
				}
			}

			if (V.farmyardBreeding) {
				if (slaveApproves) {
					slave.trust += 2;
				} else {
					slave.trust--;
				}
			}

			if (V.farmyardRestraints) {
				if (slaveApproves) {
					slave.trust += 3;
				} else {
					slave.trust -= 2;
				}
			}
		} else if (slave.trust < -50) {
			amount *= slave.devotion > 50 ? 1.2 : 0.9;

			if (V.seeBestiality) {
				if (slaveApproves) {
					slave.trust++;
				} else {
					slave.trust -= 2;
				}
			}

			if (V.farmyardBreeding) {
				if (slaveApproves) {
					slave.trust++;
				} else {
					slave.trust -= 2;
				}
			}

			if (V.farmyardRestraints) {
				if (slaveApproves) {
					slave.trust += 2;
				} else {
					slave.trust -= 3;
				}
			}
		}

		return amount;
	}
};
